image: "docker:19.03.1-dind"

# to run docker commands it needs Docker-in-Docker

services:
  - name: "docker:dind"
    entrypoint: ["env", "-u", "DOCKER_HOST"]
    command: ["dockerd-entrypoint.sh"]

variables:
  # required, see https://github.com/docker-library/docker/pull/166
  DOCKER_TLS_CERTDIR: ""

  version: "0.1.$CI_PIPELINE_IID-alpha"
  deploy_user: $deploy_user
  server_ip: $server_ip
  gitlab_docker_image: registry.gitlab.com/alessandro.piccione/cryptocurrencies-tickers-collector-service
  azure_docker_image: test000.azurecr.io/alessandro.piccione/cryptocurrencies-tickers-collector-service
  azure_registry: test000.azurecr.io


before_script: 
  - docker info
  - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY

stages: 
  - build
  - publish_azure
  - deploy

build:
  stage: build
  script: |     
    echo "build version ${version}"
    docker build --build-arg VERSION=${version} -t ${gitlab_docker_image}:${version} -t ${gitlab_docker_image}:latest .    
    # push in GitLab
    docker push ${gitlab_docker_image}:${version}
    docker push ${gitlab_docker_image}:latest

publish_azure:
  stage: publish_azure
  script: |     
    docker build --build-arg VERSION=${version} -t ${azure_docker_image}:${version} -t ${azure_docker_image}:latest .    
    echo ${AZURE_REGISTRY_PWD} | docker login ${azure_registry} -u ${AZURE_REGISTRY_USER} --password-stdin  
    echo push image ${azure_docker_image}:${version} 
    docker push ${azure_docker_image}:${version} 


deploy:
  stage: deploy
  image: alpine
#  before_script:
#    - apk add openssh-client
#    - eval $(ssh-agent -s)
#    - echo "$SSH_PRIVATE_KEY" | tr
  script: echo TBD
  

#deploy_bak:
#  stage: deploy
#  script: |
#    echo "deploy!"
#    && ssh ${deploy_user}@${server_ip} /bin/bash -s << EOT
#    echo ${server_ip}
#    EOT
    
# && ssh-keygen -t rsa -b 4096   ssh-keygen command not found